package edu.ntut.curtain;


import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;

import edu.ntut.curtain.vo.Curtain;

@Path("/Message")
public class Message {
	

	static String msg = "something";
	
	private static float temp;
	private static int light;
	private static int mode;//0：auto;1:manual
	private static int motorStatus = 1;//0:stop;1:open;2:close
	private static int curtainStatus = 1;//0:open;1:close	
	
	public float getTemp() {
		return temp;
	}

	public void setTemp(float temp) {
		Message.temp = temp;
	}

	public int getLight() {
		return light;
	}

	public void setLight(int light) {
		Message.light = light;
	}

	public int getMode() {
		return mode;
	}

	public void setMode(int mode) {
		Message.mode = mode;
	}

	public int getMotorStatus() {
		return motorStatus;
	}

	public void setMotorStatus(int motorStatus) {
		Message.motorStatus = motorStatus;
	}

	public int getCurtainStatus() {
		return curtainStatus;
	}

	public void setCurtainStatus(int curtainStatus) {
		Message.curtainStatus = curtainStatus;
	}

	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		Message.msg = msg;
	}

	@GET
	@Path("saveMsg")
	public Object saveMsg(@QueryParam("msg") String msg) {
		
		setMsg(msg);
		System.out.println("save Arduino Msesssage");

		String[] arduinoMsg = msg.split(";");
		
		for (String titles : arduinoMsg) {
			
			String[] title = titles.split(":");
			if ( title[0].equals("temp")) {
				System.out.print("temp:"+ title[1] + " ");
				setTemp(Float.parseFloat(title[1]));
			}
			else if ( title[0].equals("light")) {
				System.out.print("light:"+ title[1] + " ");
				setLight(Integer.parseInt(title[1]));
			}
			else if ( title[0].equals("mode")) {
				System.out.print("mode:"+ title[1] + " ");
				setMode(Integer.parseInt(title[1]));
			}
			else if ( title[0].equals("motorStatus")) {
				System.out.print("motorStatus:"+ title[1] + " ");
				setMotorStatus(Integer.parseInt(title[1]));
			}
			else if ( title[0].equals("curtainStatus")) {
				System.out.print("curtainStatus:"+ title[1] );
				setCurtainStatus(Integer.parseInt(title[1]));
			}
			System.out.println("");
		}
		
		return "ok";
	}

	@GET
	@Path("getTemp")
	@Produces(MediaType.APPLICATION_JSON)
	public Object getNowTemp() {
		System.out.println("getTemp");
		Curtain curtain = new Curtain();
		curtain.setTemp(getTemp());
		return curtain;		
	}
	
	@GET
	@Path("getLight")
	@Produces(MediaType.APPLICATION_JSON)
	public Object getNowLight() {
		System.out.println("getLight");
		Curtain curtain = new Curtain();
		curtain.setLight(getLight());
		return curtain;				
	}
	
	@GET
	@Path("getMode")
	public Object getNowMode() {
		System.out.println("getMode");
		Curtain curtain = new Curtain();
		
		if ( getMode() == 0 )//0:auto
			curtain.setMode("auto");
		else //manual
			curtain.setMode("manual");
		
		return curtain;		
	}
	
	@GET
	@Path("getMotorStatus")
	@Produces(MediaType.APPLICATION_JSON)
	public Object getNowMotorStatus() {
		System.out.println("getMotorStatus");
		Curtain curtain = new Curtain();
		
		if ( getMotorStatus() == 0 )//0:stop;1:open;2:close
			curtain.setMotorStatus("stop");
		else if ( getMotorStatus() == 1 )
			curtain.setMotorStatus("open");
		else
			curtain.setMode("close");
		
		return curtain;		
	}
	
	@GET
	@Path("getCurtainStatus")
	@Produces(MediaType.APPLICATION_JSON)
	public Object getNowCurtainStatus() {
		System.out.println("getCurtainStatus");
		Curtain curtain = new Curtain();
		
		if ( getCurtainStatus() == 0 )//0:open;1:close	
			curtain.setCurtainStatus("open");
		else
			curtain.setCurtainStatus("close");
		
		return curtain;	
	}
	
	@GET
	@Path("getMsg")
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes("application/x-www-form-urlencoded")
	public Object getNowMsg() {
		System.out.println("getMsg");
		Curtain curtain = new Curtain();
		curtain.setTemp(getTemp());
		curtain.setLight(getLight());
		if ( getMode() == 0 )//0:auto
			curtain.setMode("auto");
		else //manual
			curtain.setMode("manual");
		
		if ( getMotorStatus() == 0 )//0:stop;1:open;2:close
			curtain.setMotorStatus("stop");
		else if ( getMotorStatus() == 1 )
			curtain.setMotorStatus("open");
		else
			curtain.setMode("close");
		
		if ( getCurtainStatus() == 0 )//0:open;1:close	
			curtain.setCurtainStatus("open");
		else
			curtain.setCurtainStatus("close");
		
		return curtain;
	}
}
